{
	"License header" : {
		"prefix": "license",
		"body": [
			"// Copyright (c) 2017 Vidrio Technologies, All Rights Reserved",
			"// Author: Nathan Clack <nathan@vidriotech.com>"
		],
		"description": "Insert license/author comment"
	},
	"Header guard" : {
		"prefix": "#ifndef",
		"body": [
			"#ifndef $1",
			"#define $1",
			"",
			"$2",
			"",
			"#endif // $1"
		],
		"description": "Insert author comment"
	},
	"C++ Extern C Gaurd": {
		"prefix": "cplusplus",
		"body": [
			"#ifdef __cplusplus",
			"extern \"C\" {",
			"#endif //__cplusplus",
			"",
			"$0",
			"",
			"#ifdef __cplusplus",
			"} // end extern \"C\"",
			"#endif //__cplusplus"
		],
		"description": "extern C block"
	},
	"main":{
		"prefix" : "main",
		"description": "stub out standard main function",
		"body": [
			"int main(int argc,char* argv[]) {",
			"\t$0",
			"\treturn 0;",
			"}"
		]
	},
	"logger" : {
		"prefix" : "logger",
		"description": "Nathan's standard logger definition",
		"body": [
			"static void logger(int is_error,const char *file,int line,const char* function,const char *fmt,...) {",
			"\tchar buf1[1024]={0},buf2[1024]={0};",
			"\tva_list ap;",
			"\tva_start(ap,fmt);",
			"\tvsprintf(buf1,fmt,ap);",
			"\tva_end(ap);",
			"#if 1",
			"\tsprintf(buf2,\"%s(%d): %s()\\n\\t - %s\\n\",file,line,function,buf1);",
			"#else",
			"\tsprintf(buf2,\"%s\\n\",buf1);",
			"#endif",
			"\tputs(buf2);",
			"}"						
		]
	},
	"LOG macro" : {
		"prefix": "#define LOG",
		"description": "Nathan's standard LOG macro",
		"body": "#define LOG(...) logger(0,__FILE__,__LINE__,__FUNCTION__,__VA_ARGS__)"
	},
	"ERR macro" : {
		"prefix": "#define ERR",
		"description": "Nathan's standard ERR macro",
		"body": "#define ERR(...) logger(1,__FILE__,__LINE__,__FUNCTION__,__VA_ARGS__)"
	},
	"CHECK macro (error code)" : {
		"prefix": "#define CHECK",
		"description": "Nathan's standard CHECK macro for error codes",
		"body": "#define CHECK(ecode) do{if(ecode) {ERR(\"Error: %s\/n\",#ecode); ${1:goto Error;}}}while(0)"
	},
	"CHECK macro (assert)" : {
		"prefix": "#define CHECK",
		"description": "Nathan's standard CHECK macro for error codes",
		"body": "#define CHECK(e) do{if(!(e)) {ERR(\"Error: %s\/n\",#e); ${1:goto Error;}}}while(0)"
	},
	"comment section" : {
		"prefix": "section",
		"description": "Nathan's section header comment",
		"body": [
			"//",
			"//                  $0",
			"//"]
	}
}